#include <unistd.h>
#include <sys/types.h>
#include "castem.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include<math.h>

static int fdecr[64][2],fdlir[64][2];
static  pid_t pid[64];
#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#include <stdio.h>

#define dlopen(name, mode) LoadLibrary (TEXT (name))
#define dlsym(handle, func) GetProcAddress (handle, func)
#define dlclose(handle) FreeLibrary (handle)
#define dlerror() "error %d occurred", GetLastError ()

typedef double (*MatFctPtr)(const double *const);

/* code copie du site de microsoft et adapte*/


HANDLE g_hChildStd_IN_Rd = NULL;
HANDLE g_hChildStd_IN_Wr = NULL;
HANDLE g_hChildStd_OUT_Rd = NULL;
HANDLE g_hChildStd_OUT_Wr = NULL;

HANDLE g_hInputFile = NULL;

void CreateChildProcess(char *);
void WriteToPipe(void);
void ReadFromPipe(void);
#else
#include <dlfcn.h>
typedef double (*MatFctPtr)(const double *const);
#endif

void* lance(lacomm,ith)
   char* lacomm;
   cast_int* ith;
 {
	 int i;

#ifndef WIN32
/*  on cree les deux pipe de communication */
/*   int i; */
  pipe(fdecr[*ith]);
  pipe(fdlir[*ith]);

  pid[*ith]=vfork();
  if (pid[(*ith)]< 0) printf("echec fork \n");
  if (pid[*ith]!=0) {close(fdlir[*ith][1]); close(fdecr[*ith][0]); return;};
/*  il faut fermer les filedescriptors sauf fdecr(0) et fdlir(1) */
  for (i=3;i<200;i++) {
              if ((i != fdecr[*ith][0]) && (i != fdlir[*ith][1])) close(i);};
/*  on renvoie fdecr(0) sur 0 et fdlir(1) sur 1 */
  close(0);dup2(fdecr[*ith][0],0); close (fdecr[*ith][0]);
  close(1);dup2(fdlir[*ith][1],1); close (fdlir[*ith][1]);
/*  on execute la commande */
  execlp("sh","sh","-c",lacomm,0);
  close (fdlir[*ith][0]);close (fdecr[*ith][1]);
#else /* WIN32 */

   char lacommr[503];
   strcpy(lacommr,"/c ");
   strcpy(lacommr+3,lacomm);


   SECURITY_ATTRIBUTES saAttr;

// Set the bInheritHandle flag so pipe handles are inherited.

   saAttr.nLength = sizeof(SECURITY_ATTRIBUTES);
   saAttr.bInheritHandle = TRUE;
   saAttr.lpSecurityDescriptor = NULL;

// Create a pipe for the child process's STDOUT.

   if ( ! CreatePipe(&g_hChildStd_OUT_Rd, &g_hChildStd_OUT_Wr, &saAttr, 0) )
      printf ("StdoutRd CreatePipe\n");

// Ensure the read handle to the pipe for STDOUT is not inherited.

   if ( ! SetHandleInformation(g_hChildStd_OUT_Rd, HANDLE_FLAG_INHERIT, 0) )
      printf("Stdout SetHandleInformation\n");

// Create a pipe for the child process's STDIN.

   if (! CreatePipe(&g_hChildStd_IN_Rd, &g_hChildStd_IN_Wr, &saAttr, 0))
      printf("Stdin CreatePipe\n");

// Ensure the write handle to the pipe for STDIN is not inherited.

   if ( ! SetHandleInformation(g_hChildStd_IN_Wr, HANDLE_FLAG_INHERIT, 0) )
      printf("Stdin SetHandleInformation\n");

// Create the child process.

   CreateChildProcess(lacommr);


// The remaining open handles are cleaned up when this process terminates.
// To avoid resource leaks in a larger application, close handles explicitly.

#endif /* WIN32*/
   return 0;
}


#ifdef WIN32

void CreateChildProcess(char * lacomm)
// Create a child process that uses the previously created pipes for STDIN and STDOUT.
{
   TCHAR szCmdline[]=TEXT("child");
   PROCESS_INFORMATION piProcInfo;
   STARTUPINFO siStartInfo;
   BOOL bSuccess = FALSE;

// Set up members of the PROCESS_INFORMATION structure.

   ZeroMemory( &piProcInfo, sizeof(PROCESS_INFORMATION) );

// Set up members of the STARTUPINFO structure.
// This structure specifies the STDIN and STDOUT handles for redirection.

   ZeroMemory( &siStartInfo, sizeof(STARTUPINFO) );
   siStartInfo.cb = sizeof(STARTUPINFO);
   siStartInfo.hStdError = g_hChildStd_OUT_Wr;
   siStartInfo.hStdOutput = g_hChildStd_OUT_Wr;
   siStartInfo.hStdInput = g_hChildStd_IN_Rd;
   siStartInfo.dwFlags |= STARTF_USESTDHANDLES;

// Create the child process.

   bSuccess = CreateProcess("c:\\windows\\system32\\cmd.exe",
      lacomm,        // command line
      NULL,          // process security attributes
      NULL,          // primary thread security attributes
      TRUE,          // handles are inherited
      0,             // creation flags
      NULL,          // use parent's environment
      NULL,          // use parent's current directory
      &siStartInfo,  // STARTUPINFO pointer
      &piProcInfo);  // receives PROCESS_INFORMATION

   // If an error occurs, exit the application.
   if ( ! bSuccess )
     printf (" CreateProcess failed \n");
   else
   {
      // Close handles to the child process and its primary thread.
      // Some applications might keep these handles to monitor the status
      // of the child process, for example.

      CloseHandle(piProcInfo.hProcess);
      CloseHandle(piProcInfo.hThread);
   }

}

#endif /* WIN32 */



void* ecrdon(lacomm,lpos,ith)
   char* lacomm;
   cast_int* lpos;
   cast_int* ith;
/*  ici on est cense passer l'input de la commande */
{
#ifndef WIN32
  int lposc;
/* printf("dans ecrdon %i %s \n",*ith,lacomm);*/
  lposc=*lpos;
  write(fdecr[*ith][1],lacomm,lposc);
  close(fdecr[*ith][1]);

#else   /* WIN32 */

   DWORD dwRead, dwWritten;
   BOOL bSuccess = FALSE;
      dwRead=*lpos;
      bSuccess = WriteFile(g_hChildStd_IN_Wr, lacomm, dwRead, &dwWritten, NULL);


// Close the pipe handle so the child process stops reading.

   if ( ! CloseHandle(g_hChildStd_IN_Wr) )
      printf("StdInWr CloseHandle \n");

// Close the write end of the pipe before reading from the
// read end of the pipe, to control child process execution.
// The pipe is assumed to have enough buffer space to hold the
// data the child process has already written to it.

    if (!CloseHandle(g_hChildStd_OUT_Wr))
      printf("StdOutWr CloseHandle \n");

#endif /* WIN32 */

}
void* lires(lacomm,iend,istat,ith)
   char* lacomm;
   cast_int* iend;
   cast_int* istat;
   cast_int* ith;
/*  ici on est cense recuperer l'output de la commande */
{
#ifndef WIN32
  int istatc;
/*  printf("dans lires  %i  \n",*ith);*/
  *iend=read(fdlir[*ith][0],lacomm,72);
/* printf("lires apres read %i %i \n",*ith,*iend);*/
  if (*iend<=0) { close(fdlir[*ith][0]);
                  waitpid(pid[*ith],&istatc,0);};
  *istat=istatc;
#else /* WIN32 */
   DWORD dwRead, dwWritten;
   BOOL bSuccess = FALSE;
   int iend4;

      bSuccess = ReadFile( g_hChildStd_OUT_Rd, lacomm, 72, &iend4, NULL);
      *iend=iend4;
      *istat=0;
      if (*iend <= 0) {
  CloseHandle(g_hChildStd_OUT_Wr);
  CloseHandle(g_hChildStd_IN_Wr);
  CloseHandle(g_hChildStd_OUT_Rd);
  CloseHandle(g_hChildStd_IN_Rd);
                      }

#endif /* WIN32*/

}

/*******************************************************************/
/* ICI, je vais mettre les entrees/sorties binaires                */
/*  b_ecrdon envoie un tableau de dimension n sur m                */
/*   mais, contrairement  la fonction ecrdon_                     */
/*   je ne clos pas le pipe tant que je n'ai pas fini              */
/*   d'envoyer mes tableaux (je veux pouvoir en envoyer plusieurs) */
/*   lorsque j'ai fini, ith==nb_tableaux                           */
/*  b_lires rcupre le rsultat : un entier long                  */
/*      l1 nombre de tableaux  rcuprer                          */
/*    puis, pour chaque tableau,                                   */
/*      l2 : premire dimension du tableau                         */
/*      l3 : seconde dimension du tableau                          */
/*******************************************************************/

void* becrdon(entree,ith,i_tableau,nb_tableaux,type_tableau,nombre_elements,nombre_points_gauss)
   void* entree;
   cast_int* nombre_elements;
   cast_int* nombre_points_gauss;
   cast_int* ith;
   cast_int* i_tableau;
   cast_int* nb_tableaux;
   cast_int* type_tableau;
/*  ici on est cense passer l'input de la commande */
{
#ifndef WIN32
  int i1,lposc;
  long l1,nbr,nb_enr;
  cast_double *t1;
/*  lposc=*long_entree;*/

/*  printf("%ld\n",*long_entree);  */
/*  write(fdecr[*ith][1],entree,lposc);*/
  if (*i_tableau == 1) write(fdecr[*ith][1],nb_tableaux,sizeof(cast_int));
  write(fdecr[*ith][1],i_tableau,sizeof(cast_int));
  write(fdecr[*ith][1],type_tableau,sizeof(cast_int));
  write(fdecr[*ith][1],nombre_elements,sizeof(cast_int));
  write(fdecr[*ith][1],nombre_points_gauss,sizeof(cast_int));
  if (*type_tableau == 1) nbr = sizeof(cast_double) * (*nombre_points_gauss) * (*nombre_elements);
  if (*type_tableau == 2) nbr = sizeof(cast_int)* (*nombre_points_gauss) * (*nombre_elements);
  if (*type_tableau == 3) nbr = 8 * sizeof(char) * (*nombre_points_gauss) * (*nombre_elements);
  nb_enr = (*nombre_points_gauss) * (*nombre_elements);
/*  t1 = entree ;
  for (i1=0;i1<nb_enr;i1++) printf("==> %lf \n",t1[i1]); */
  write(fdecr[*ith][1],entree,nbr);

  if (i_tableau == nb_tableaux)  close(fdecr[*ith][1]);

#else   /* WIN32 */
/*
   DWORD dwRead, dwWritten;
   BOOL bSuccess = FALSE;
      dwRead=*long_entree;
      bSuccess = WriteFile(g_hChildStd_IN_Wr, entree, dwRead, &dwWritten, NULL);

*/
// Close the pipe handle so the child process stops reading.
/*
   if ( ! CloseHandle(g_hChildStd_IN_Wr) )
      printf("StdInWr CloseHandle \n");
*/
// Close the write end of the pipe before reading from the
// read end of the pipe, to control child process execution.
// The pipe is assumed to have enough buffer space to hold the
// data the child process has already written to it.
/*
    if (!CloseHandle(g_hChildStd_OUT_Wr))
      printf("StdOutWr CloseHandle \n");
*/
#endif /* WIN32 */
}



void* blires(sortie,iend,istat,ith)
   void* sortie;
   cast_int* iend;
   cast_int* istat;
   cast_int* ith;
/*  ici on est cense recuperer l'output de la commande */
{
#ifndef WIN32
  int istatc,i1,nbr;
  cast_int nb_sortie,numero_sortie[1024],long_sortie[1024],type_sortie[1024] ;
  cast_int elements_sortie[1024],points_de_gauss_sortie[1024];
  char nb1[9];

    /*  *iend=read(fdlir[*ith][0],sortie,72);*/
  *iend=read(fdlir[*ith][0],&nb_sortie,sizeof(cast_int));
  for (i1=0;i1<nb_sortie;i1++)
     {
       *iend=read(fdlir[*ith][0],&numero_sortie[i1],sizeof(cast_int));
       *iend=read(fdlir[*ith][0],&type_sortie[i1],sizeof(cast_int));
       *iend=read(fdlir[*ith][0],&elements_sortie[i1],sizeof(cast_int));
       *iend=read(fdlir[*ith][0],&points_de_gauss_sortie[i1],sizeof(cast_int));
       if (type_sortie[i1] == 1) nbr = sizeof(cast_double);
       if (type_sortie[i1] == 2) nbr = sizeof(cast_int);
       if (type_sortie[i1] == 3) nbr = 8 * sizeof(char);

       *iend=read(fdlir[*ith][0],sortie,nbr*elements_sortie[i1]*points_de_gauss_sortie[i1]);
       if (*iend<=0) { close(fdlir[*ith][0]);
                  waitpid(pid[*ith],&istatc,0);};
     }
/* printf("lires apres read %i %i \n",*ith,*iend);
  if (*iend<=0) { close(fdlir[*ith][0]);
                  waitpid(pid[*ith],&istatc,0);};*/
  *istat=istatc;
#else /* WIN32 */
/*   DWORD dwRead, dwWritten;
   BOOL bSuccess = FALSE;
   int iend4;

      bSuccess = ReadFile( g_hChildStd_OUT_Rd, sortie, 72, iend, NULL);
  for (i1=0;i1<nb_sortie;i1++)
     {
	 bSuccess = ReadFile( g_hChildStd_OUT_Rd, &long_sortie[i1],sizeof(cast_int) , &iend4, NULL);
	 bSuccess = ReadFile( g_hChildStd_OUT_Rd, &type_sortie[i1],sizeof(cast_int) , &iend4, NULL);
	 bSuccess = ReadFile( g_hChildStd_OUT_Rd, sortie, long_sortie[i1] , &iend4, NULL);
	 *iend = iend4;
*/
	 /*	*iend=read(fdlir[*ith][0],&long_sortie[i1],sizeof(cast_int));
	*iend=read(fdlir[*ith][0],&type_sortie[i1],sizeof(cast_int));
       *iend=read(fdlir[*ith][0],sortie,long_sortie[i1]);
       if (*iend<=0) { close(fdlir[*ith][0]);
                  waitpid(pid[*ith],&istatc,0);};*/
/*     }

      *istat=0;
      if (*iend <= 0) {
  CloseHandle(g_hChildStd_OUT_Wr);
  CloseHandle(g_hChildStd_IN_Wr);
  CloseHandle(g_hChildStd_OUT_Rd);
  CloseHandle(g_hChildStd_IN_Rd);
                      }
*/
#endif   /* WIN32*/

}

/*
 *     DESCRIPTION DE L'INTERFACE :
 *     --------------------------
 *     ENTREE : VALPAR : REAL*8(NPARA), valeurs des parametres
 *              NPARA  : INTEGER, nombre de parametres
 *              NLOI : Numro de la loi
 *     SORTIE : VALCMP : REAL*8, valeur de la composante
 *              IERUT  : INTEGER, code retour
 *                       IERUT= 0 : OK
 *                       IERUT<>0 : NOOK
 *                       Les cas d'erreur pris en charge par la
 *                       programmation de l'utilisateur doivent
 *                       faire l'objet d'une affectation de IERUT
 *                       differente de 0
 */
/* debut a decommenter*/
void loiexterne(double *valpar,
		 double *valcmp,
		 MatFctPtr* loi,
		 cast_int *ierut)
{
  *valcmp = (*loi)(valpar);
  if(isnan(*valcmp)){
    *ierut=2;
  }
}
/*fin a decommenter */

/*
 * Rcupre le numro de la loi Pliades en fonction de son nom
 * Le numro correspond  son rang dans le fichier LOI.inc
 *
 * mmod : Nom du modle
 * lm : longueur de la chane de caractres prcdente
 * mlib : Nom de la librairie
 * ll : longueur de la chane de caractres prcdente
 * nomco4 : Nom du paramtre  valuer
 * nompar : Noms des paramtres de la liste d'entre
 * npara : Nombre de paramtres
 * lib : Pointeur sur la librairie dynamique ouverte
 * nloi : numro du modle
 * En cas d'erreur, le modle retourn est nul
 */
/* debut a decommenter*/
void numloi(char *const mmod,cast_int *lm,char *mlib,cast_int *ll,
	     char *const unused1,char *unused2,
	     cast_int *const npara,void**lib,MatFctPtr* nloi,
	     const size_t unused3,const size_t unused4,
	     const size_t unused5,const size_t unused6)
{
  char * modele;
  char * librairie;
  unsigned short *n;

  (void) unused1;
  (void) unused2;
  (void) unused3;
  (void) unused4;
  (void) unused5;
  (void) unused6;

  modele = (char *) malloc((*lm+7)*sizeof(char));

  if(!modele){
    fprintf(stderr,"mmoire insuffisante\n");
    exit(EXIT_FAILURE);
  }
  strncpy(modele,mmod,(unsigned int)*lm);
  modele[*lm]='\0';
  /*fin a decommenter */
  /* Initialisation  0 du numro de modle */
  /* debut a decommenter*/
*nloi=0;

  if (*ll) {
    librairie  = (char *) malloc((*ll+1)*sizeof(char));
    if(!librairie){
      fprintf(stderr,"mmoire insuffisante\n");
      exit(EXIT_FAILURE);
    }
    librairie[*ll]='\0';
    strncpy(librairie,mlib,(unsigned int)*ll);
    *lib= (void *) dlopen (librairie, RTLD_LAZY);
    free(librairie);
  }
  else {
    *lib = (void *) dlopen (NULL, RTLD_LAZY);
  }
  if (!(*lib)){
    fprintf(stderr,"%s\n",dlerror());
    return;
  }
  /*fin a decommenter */
  /* Conversion des chanes de caractres en string */
  /* debut a decommenter*/
*nloi=(MatFctPtr)dlsym(*lib,modele);

  if (!(*nloi)) {
    fprintf(stderr,"%s\n",dlerror());
    return;
  }
  /*fin a decommenter */
  /* Vrification du nombre de paramtres */
  /* debut a decommenter*/
  modele[*lm]='_';
  modele[*lm+1]='n';
  modele[*lm+2]='a';
  modele[*lm+3]='r';
  modele[*lm+4]='g';
  modele[*lm+5]='s';
  modele[*lm+6]='\0';

  n=(unsigned short *) dlsym(*lib,modele);
  if (!n) {
    fprintf(stderr,"%s\n",dlerror());
    dlclose(*lib);
    return;
  }

  if ( *n != (unsigned short) *npara) {
    *nloi=0;
    fprintf(stderr,"Erreur lors de l'valuation du modle %s\n",modele);
    fprintf(stderr,"Nombre de paramtres reus  : %d\n",*npara);
    fprintf(stderr,"Nombre de paramtres requis : %d\n",*n);
    dlclose(*lib);
  }
  free(modele);
}
/*fin a decommenter */
/* Fermeture de la librairie */
/* debut a decommenter*/
void dlclose_(void **lib) {
  dlclose(*lib);
}
/*fin a decommenter */
